# Interface ISynchronizer

public interface ISynchronizer
A synchronizer which maintains a list of registered partners and, on behalf of each partner, it keeps resource level synchronization information (a byte array). Sync info is saved only when the workspace is saved.

See Also:
  - `IWorkspace.getSynchronizer()`
Restriction:
  This interface is not intended to be implemented by clients.
Restriction:
  This interface is not intended to be extended by clients.

## Method Summary

Modifier and Type
Method
Description
`void`
`accept(QualifiedName partner, IResource start, IResourceVisitor visitor, int depth)`
Visits the given resource and its descendents with the specified visitor if sync information for the given sync partner is found on the resource.
`void`
`add(QualifiedName partner)`
Adds the named synchronization partner to this synchronizer's registry of partners.
`void`
`flushSyncInfo(QualifiedName partner, IResource resource, int depth)`
Discards the named partner's synchronization information associated with the specified resource and its descendents to the specified depth.
`QualifiedName[]`
`getPartners()`
Returns a list of synchronization partner names currently registered with this synchronizer.
`byte[]`
`getSyncInfo(QualifiedName partner, IResource resource)`
Returns the named sync partner's synchronization information for the given resource.
`void`
`remove(QualifiedName partner)`
Removes the named synchronization partner from this synchronizer's registry.
`void`
`setSyncInfo(QualifiedName partner, IResource resource, byte[] info)`
Sets the named sync partner's synchronization information for the given resource.

## Method Details

### accept

void accept(QualifiedName partner, IResource start, IResourceVisitor visitor, int depth) throws CoreException
Visits the given resource and its descendents with the specified visitor if sync information for the given sync partner is found on the resource. If sync information for the given sync partner is not found on the resource, still visit the children of the resource if the depth specifies to do so.

Parameters:
  `partner` - the sync partner name
  `start` - the parent resource to start the visitation
  `visitor` - the visitor to use when visiting the resources
  `depth` - the depth to which members of this resource should be visited. One of `IResource.DEPTH_ZERO`, `IResource.DEPTH_ONE`, or `IResource.DEPTH_INFINITE`.
Throws:
  `CoreException` - if this operation fails. Reasons include:
  - The resource does not exist.
  - `IResourceStatus.PARTNER_NOT_REGISTERED` The sync partner is not registered.

### add

void add(QualifiedName partner)
Adds the named synchronization partner to this synchronizer's registry of partners. Once a partner's name has been registered, sync information can be set and retrieve on resources relative to the name. Adding a sync partner multiple times has no effect.

Parameters:
  `partner` - the partner name to register
See Also:
  - `remove(QualifiedName)`

### flushSyncInfo

void flushSyncInfo(QualifiedName partner, IResource resource, int depth) throws CoreException
Discards the named partner's synchronization information associated with the specified resource and its descendents to the specified depth.

Parameters:
  `partner` - the sync partner name
  `resource` - the resource
  `depth` - the depth to which members of this resource should be visited. One of `IResource.DEPTH_ZERO`, `IResource.DEPTH_ONE`, or `IResource.DEPTH_INFINITE`.
Throws:
  `CoreException` - if this operation fails. Reasons include:
  - The resource does not exist.
  - `IResourceStatus.PARTNER_NOT_REGISTERED` The sync partner is not registered.

### getPartners

QualifiedName[] getPartners()
Returns a list of synchronization partner names currently registered with this synchronizer. Returns an empty array if there are no registered sync partners.

Returns:
  a list of sync partner names

### getSyncInfo

byte[] getSyncInfo(QualifiedName partner, IResource resource) throws CoreException
Returns the named sync partner's synchronization information for the given resource. Returns `null` if no information is found.

Parameters:
  `partner` - the sync partner name
  `resource` - the resource
Returns:
  the synchronization information, or `null` if none
Throws:
  `CoreException` - if this operation fails. Reasons include:
  - `IResourceStatus.PARTNER_NOT_REGISTERED` The sync partner is not registered.

### remove

void remove(QualifiedName partner)
Removes the named synchronization partner from this synchronizer's registry. Does nothing if the partner is not registered. This discards all sync information for the defunct partner. After a partner has been unregistered, sync information for it can no longer be stored on resources.

Parameters:
  `partner` - the partner name to remove from the registry
See Also:
  - `add(QualifiedName)`

### setSyncInfo

void setSyncInfo(QualifiedName partner, IResource resource, byte[] info) throws CoreException
Sets the named sync partner's synchronization information for the given resource. If the given info is non-`null` and the resource neither exists nor is a phantom, this method creates a phantom resource to hang on to the info. If the given info is `null`, any sync info for the resource stored by the given sync partner is discarded; in some cases, this may result in the deletion of a phantom resource if there is no more sync info to maintain for that resource.

Sync information is not stored on the workspace root. Attempts to set information on the root will be ignored.

Parameters:
  `partner` - the sync partner name
  `resource` - the resource
  `info` - the synchronization information, or `null`
Throws:
  `CoreException` - if this operation fails. Reasons include:
  - `IResourceStatus.PARTNER_NOT_REGISTERED` The sync partner is not registered.